/*
 * This file is part of Jenirok.
 *
 * Jenirok is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Jenirok is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Jenirok.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef CONNECTIONMANAGER_H
#define CONNECTIONMANAGER_H

#include <QtCore/QObject>
#include <QtCore/QTimerEvent>
#include <QtDBus/QDBusInterface>
#include <QtDBus/QDBusMessage>

class ConnectionManager : public QObject
{
    Q_OBJECT

public:
    ConnectionManager(QObject* parent = 0);
    bool connect();
    bool disconnect();
    bool isConnected();
    static unsigned int const TIMEOUT = 20000;

protected:
    virtual void timerEvent(QTimerEvent* event);

private slots:
    void stateChange(const QDBusMessage& rep);
    void connectionChange(const QDBusMessage& rep);

private:
    bool waitSignal();
    bool ready_;
    bool connected_;
    bool timeout_;
    bool ignoreStateChanges_;
    int timer_;
    QDBusInterface *icd2interface_;
};

#endif
